# Class OjSelectMany

The component WebElement for oj-select-many. Do not instantiate this class directly, instead, use ojSelectMany.

#### Hierarchy

- OjSelectManyBase
  - OjSelectMany

#####
Index

### Constructors

constructor

### Methods

changeMessagesCustom
changeValue
changeValueOptions
clear
click
findElement
findElements
getAttribute
getCssValue
getDescribedBy
getDisabled
getDisplayOptions
getDriver
getHelp
getHelpHints
getId
getLabelEdge
getLabelHint
getLabelledBy
getLocation
getMaximumResultCount
getMessagesCustom
getMinimumResultsForSearch
getOptionRenderer
getOptions
getOptionsKeys
getPickerAttributes
getPlaceholder
getProperty
getReadonly
getRect
getRenderMode
getRequired
getShadowRoot
getSize
getTagName
getText
getTranslations
getUserAssistanceDensity
getValid
getValue
getValueOptions
hasSize
hasVisibility
isDisplayed
isEnabled
isSelected
sendKeys
serialize
setProperty
submit
takeScreenshot
whenBusyContextReady
whenReady
buildId
equals
extractId
isId

## Constructors

### constructor

- new OjSelectMany(el, locators): OjSelectMany

- Constructor. Pass an instance of WebDriver's WebElement that represents the DOM node on which we"ll perform operations.

  #### Parameters

  - ##### el: WebElement

    The basic WebElement with which this WebElement will work.

  - ##### locators: ElementLocators

  #### Returns OjSelectMany

  Inherited from OjSelectManyBase.constructor

## Methods

### changeMessagesCustom

- changeMessagesCustom(messagesCustom): Promise<void>

- Sets the value of `messagesCustom` property. A list of messages added by an application to the component. See the Help documentation for more information.

  #### Parameters

  - ##### messagesCustom: object[]

    The value to set for `messagesCustom`

  #### Returns Promise<void>

  Inherited from OjSelectManyBase.changeMessagesCustom

### changeValue

- changeValue(value): Promise<void>

- Sets the value of "value" property. The value of the element.

  #### Parameters

  - ##### value: any[]

    The value to set for "value"

  #### Returns Promise<void>

  Overrides OjSelectManyBase.changeValue

### changeValueOptions

- changeValueOptions(valueOptions): Promise<void>

- Sets the value of `valueOptions` property. The current values of the element and their associated display labels.

  #### Parameters

  - ##### valueOptions: ValueOptions[]

    The value to set for `valueOptions`

  #### Returns Promise<void>

  Inherited from OjSelectManyBase.changeValueOptions

### clear

- clear(): Promise<void>

- Clears the value

  #### Returns Promise<void>

  Overrides OjSelectManyBase.clear

### click

- click(): Promise<void>

- ### Inherit Doc

  #### Returns Promise<void>

  Inherited from OjSelectManyBase.click

### findElement

- findElement(locator): WebElementPromise

- ### Inherit Doc

  #### Parameters

  - ##### locator: Locator

  #### Returns WebElementPromise

  Inherited from OjSelectManyBase.findElement

### findElements

- findElements(locator): Promise<WebElement[]>

- ### Inherit Doc

  #### Parameters

  - ##### locator: Locator

  #### Returns Promise<WebElement[]>

  Inherited from OjSelectManyBase.findElements

### getAttribute

- getAttribute(attributeName): Promise<string>

- ### Inherit Doc

  #### Parameters

  - ##### attributeName: string

  #### Returns Promise<string>

  Inherited from OjSelectManyBase.getAttribute

### getCssValue

- getCssValue(cssStyleProperty): Promise<string>

- ### Inherit Doc

  #### Parameters

  - ##### cssStyleProperty: string

  #### Returns Promise<string>

  Inherited from OjSelectManyBase.getCssValue

### getDescribedBy

- getDescribedBy(): Promise<string>

- Gets the value of `describedBy` property. The form component's oj-label automatically sets described-by to make it accessible. It is not meant to be set by application developer.

  #### Returns Promise<string>

  The value of `describedBy` property.

  Inherited from OjSelectManyBase.getDescribedBy

### getDisabled

- getDisabled(): Promise<boolean>

- Gets the value of `disabled` property. Specifies whether the component is disabled. The default is false.

  #### Returns Promise<boolean>

  The value of `disabled` property.

  Inherited from OjSelectManyBase.getDisabled

### getDisplayOptions

- getDisplayOptions(): Promise<DisplayOptions>

- Gets the value of `displayOptions` property. Display options for auxiliary content that determines whether or not it should be displayed.

  #### Returns Promise<DisplayOptions>

  The value of `displayOptions` property.

  Inherited from OjSelectManyBase.getDisplayOptions

### getDriver

- getDriver(): WebDriver

- #### Returns WebDriver

  The parent driver for this instance.

  Inherited from OjSelectManyBase.getDriver

### getHelp

- getHelp(): Promise<Help>

- Gets the value of `help` property. Form component help information.

  #### Returns Promise<Help>

  The value of `help` property.

  Inherited from OjSelectManyBase.getHelp

### getHelpHints

- getHelpHints(): Promise<HelpHints>

- Gets the value of `helpHints` property. Represents hints for an oj-form-layout element to render help information on the label of the editable component.

  #### Returns Promise<HelpHints>

  The value of `helpHints` property.

  Inherited from OjSelectManyBase.getHelpHints

### getId

- getId(): Promise<string>

- #### Returns Promise<string>

  A promise that resolves to the server-assigned opaque ID assigned to this element.

  Inherited from OjSelectManyBase.getId

### getLabelEdge

- getLabelEdge(): Promise<string>

- Gets the value of `labelEdge` property. Defines how the label of a component is created. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `labelEdge` property.

  Inherited from OjSelectManyBase.getLabelEdge

### getLabelHint

- getLabelHint(): Promise<string>

- Gets the value of `labelHint` property. Represents a hint for oj-form-layout element to render a label on the editable component.

  #### Returns Promise<string>

  The value of `labelHint` property.

  Inherited from OjSelectManyBase.getLabelHint

### getLabelledBy

- getLabelledBy(): Promise<string>

- Gets the value of `labelledBy` property. The oj-label sets the labelledBy property programmatically on the form component.

  #### Returns Promise<string>

  The value of `labelledBy` property.

  Inherited from OjSelectManyBase.getLabelledBy

### getLocation

- getLocation(): Promise<ILocation>

- ### Inherit Doc

  #### Returns Promise<ILocation>

  Inherited from OjSelectManyBase.getLocation

### getMaximumResultCount

- getMaximumResultCount(): Promise<number>

- Gets the value of `maximumResultCount` property. The maximum number of results displayed in the dropdown.

  #### Returns Promise<number>

  The value of `maximumResultCount` property.

  Inherited from OjSelectManyBase.getMaximumResultCount

### getMessagesCustom

- getMessagesCustom(): Promise<object[]>

- Gets the value of `messagesCustom` property. A list of messages added by an application to the component. See the Help documentation for more information.

  #### Returns Promise<object[]>

  The value of `messagesCustom` property.

  Inherited from OjSelectManyBase.getMessagesCustom

### getMinimumResultsForSearch

- getMinimumResultsForSearch(): Promise<number>

- Gets the value of `minimumResultsForSearch` property. The threshold for showing the search box in the dropdown.

  #### Returns Promise<number>

  The value of `minimumResultsForSearch` property.

  Inherited from OjSelectManyBase.getMinimumResultsForSearch

### getOptionRenderer

- getOptionRenderer(): Promise<null>

- Gets the value of `optionRenderer` property. The renderer function that renders the content of each option.

  #### Returns Promise<null>

  The value of `optionRenderer` property.

  Inherited from OjSelectManyBase.getOptionRenderer

### getOptions

- getOptions(): Promise<object | object[]>

- Gets the value of `options` property. The option items for the Select.

  #### Returns Promise<object | object[]>

  The value of `options` property.

  Inherited from OjSelectManyBase.getOptions

### getOptionsKeys

- getOptionsKeys(): Promise<OptionsKeys>

- Gets the value of `optionsKeys` property. Specify the key names to use in the options array. Depending on options-keys means that the signature of the data does not match what is supported by the options attribute.

  #### Returns Promise<OptionsKeys>

  The value of `optionsKeys` property.

  Inherited from OjSelectManyBase.getOptionsKeys

### getPickerAttributes

- getPickerAttributes(): Promise<PickerAttributes>

- Gets the value of `pickerAttributes` property. The style attributes for the drop down.

  #### Returns Promise<PickerAttributes>

  The value of `pickerAttributes` property.

  Inherited from OjSelectManyBase.getPickerAttributes

### getPlaceholder

- getPlaceholder(): Promise<string>

- Gets the value of `placeholder` property. A short hint that can be displayed before user selects a value.

  #### Returns Promise<string>

  The value of `placeholder` property.

  Inherited from OjSelectManyBase.getPlaceholder

### getProperty

- getProperty<T>(propertyName): Promise<T>

- Get a named property value from this component. This function will wait for the application's busy context to complete before attempting to get the property value.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The name of the property

  #### Returns Promise<T>

  A Promise that yields a value for the named property.

  Inherited from OjSelectManyBase.getProperty

### getReadonly

- getReadonly(): Promise<boolean>

- Gets the value of `readonly` property. Specifies whether a value is readonly

  #### Returns Promise<boolean>

  The value of `readonly` property.

  Inherited from OjSelectManyBase.getReadonly

### getRect

- getRect(): Promise<IRectangle>

- ### Inherit Doc

  #### Returns Promise<IRectangle>

  Inherited from OjSelectManyBase.getRect

### getRenderMode

- getRenderMode(): Promise<string>

- Gets the value of `renderMode` property. Specifies whether to render select in JET or as a HTML Select tag.

  ### Deprecated

  Since 8.0.0. The "native" mode rendering is deprecated because JET is promoting a consistent Oracle UX over native look and feel in Redwood. Since this property takes only two values the property itself is deprecated. The theme variable "$selectRenderModeOptionDefault" is also deprecated for the same reason.

  #### Returns Promise<string>

  The value of `renderMode` property.

  Inherited from OjSelectManyBase.getRenderMode

### getRequired

- getRequired(): Promise<boolean>

- Gets the value of `required` property. Specifies whether the component is required or optional. See the Help documentation for more information.

  #### Returns Promise<boolean>

  The value of `required` property.

  Inherited from OjSelectManyBase.getRequired

### getShadowRoot

- getShadowRoot(): ShadowRootPromise

- Get the shadow root of the current web element.

  #### Returns ShadowRootPromise

  A promise that will be resolved with the elements shadow root or rejected with NoSuchShadowRootError

  Inherited from OjSelectManyBase.getShadowRoot

### getSize

- getSize(): Promise<ISize>

- ### Inherit Doc

  #### Returns Promise<ISize>

  Inherited from OjSelectManyBase.getSize

### getTagName

- getTagName(): Promise<string>

- Schedules a command to query for the tag/node name of this element.

  #### Returns Promise<string>

  A promise that will be resolved with the element's tag name.

  Inherited from OjSelectManyBase.getTagName

### getText

- getText(): Promise<string>

- ### Inherit Doc

  #### Returns Promise<string>

  Inherited from OjSelectManyBase.getText

### getTranslations

- getTranslations(): Promise<Translations>

- Gets the value of `translations` property. A collection of translated resources from the translation bundle, or null if this component has no resources.

  #### Returns Promise<Translations>

  The value of `translations` property.

  Inherited from OjSelectManyBase.getTranslations

### getUserAssistanceDensity

- getUserAssistanceDensity(): Promise<string>

- Gets the value of `userAssistanceDensity` property. Specifies the density of the form component's user assistance presentation.

  #### Returns Promise<string>

  The value of `userAssistanceDensity` property.

  Inherited from OjSelectManyBase.getUserAssistanceDensity

### getValid

- getValid(): Promise<string>

- Gets the value of `valid` property. The validity state of the component

  #### Returns Promise<string>

  The value of `valid` property.

  Inherited from OjSelectManyBase.getValid

### getValue

- getValue(): Promise<any[]>

- Gets the value of `value` property. The value of the element.

  #### Returns Promise<any[]>

  The value of `value` property.

  Inherited from OjSelectManyBase.getValue

### getValueOptions

- getValueOptions(): Promise<ValueOptions[]>

- Gets the value of `valueOptions` property. The current values of the element and their associated display labels.

  #### Returns Promise<ValueOptions[]>

  The value of `valueOptions` property.

  Inherited from OjSelectManyBase.getValueOptions

### `Protected` hasSize

- hasSize(): Condition<Promise<boolean>>

- Create a wait condition that is satisfied when the element's DOM has a non-zero size.

  ### Deprecated

  Since 11.0.0. Call the appropriate WebElement method to test the size of the element.

  #### Returns Condition<Promise<boolean>>

  The Condition to be used with driver.wait() that's satisfied when the element's DOM has a non-zero size.

  Inherited from OjSelectManyBase.hasSize

### `Protected` hasVisibility

- hasVisibility(): Condition<Promise<boolean>>

- Create a wait condition that is satisfid when the element is visible. The condition is satisfied when the element is displayed, as reported by #isDisplayed, and is scrolled into view. This is method is deprecated. Use WebElement.isDisplayed instead to test the display of the element, and scroll it into view if necessary.

  ### Deprecated

  #### Returns Condition<Promise<boolean>>

  Inherited from OjSelectManyBase.hasVisibility

### isDisplayed

- isDisplayed(): Promise<boolean>

- ### Inherit Doc

  #### Returns Promise<boolean>

  Inherited from OjSelectManyBase.isDisplayed

### isEnabled

- isEnabled(): Promise<boolean>

- ### Inherit Doc

  #### Returns Promise<boolean>

  Inherited from OjSelectManyBase.isEnabled

### isSelected

- isSelected(): Promise<boolean>

- ### Inherit Doc

  #### Returns Promise<boolean>

  Inherited from OjSelectManyBase.isSelected

### sendKeys

- sendKeys(...varArgs): Promise<void>

- ### Inherit Doc

  #### Parameters

  - ##### `Rest` ...varArgs: (string | number | Promise<string | number>)[]

  #### Returns Promise<void>

  Inherited from OjSelectManyBase.sendKeys

### serialize

- serialize(): Promise<IWebElementId>

- #### Returns Promise<IWebElementId>

  Inherited from OjSelectManyBase.serialize

### `Protected` setProperty

- setProperty<T>(propertyName, value): Promise<void>

- Set a property value on the remote element. This function first waits for the BusyContext to clear before setting the property, then after setting, waits again to ensure that no additional busy states were created due to the property setting.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The property name to set

  - ##### value: T

    The value to set for the property

  #### Returns Promise<void>

  A Promise which resolves when the remote property has been set to the value. Any value returned from the call to set the remote property is returned in the Promise.

  Inherited from OjSelectManyBase.setProperty

### submit

- submit(): Promise<void>

- ### Inherit Doc

  #### Returns Promise<void>

  Inherited from OjSelectManyBase.submit

### takeScreenshot

- takeScreenshot(optScroll?): Promise<string>

- ### Inherit Doc

  #### Parameters

  - ##### `Optional` optScroll: boolean

  #### Returns Promise<string>

  Inherited from OjSelectManyBase.takeScreenshot

### whenBusyContextReady

- whenBusyContextReady(): Promise<void>

- Returns a Promise that is resolved when the application's busy state reports ready. This method checks only that the application's busy context is ready, and not that the DOM element is actually displayed or has a physical size, such as is the case with #whenReady. Operations which are read-only in nature should call this method prior to execution.

  #### Returns Promise<void>

  A Promise which is resolved when the page's busy state is ready.

  Inherited from OjSelectManyBase.whenBusyContextReady

### whenReady

- whenReady(): Promise<void>

- Returns a Promise that is resolved when the element is ready for interaction--it is visible, has a size, and the app's busy context is ready. Operations on the DOM which rely on its physical location and size to be in a "ready" state should use this command, such as clicking, sending keys, locating child elements, and so on.

  #### Returns Promise<void>

  A Promise that's resolved when all conditions are met.

  Inherited from OjSelectManyBase.whenReady

### `Static` buildId

- buildId(id, opt_noLegacy?): IWebElementId

- #### Parameters

  - ##### id: string

    The raw ID.

  - ##### `Optional` opt_noLegacy: boolean

    Whether to exclude the legacy element key.

  #### Returns IWebElementId

  The element ID for use with WebDriver's wire protocol.

  Inherited from OjSelectManyBase.buildId

### `Static` equals

- equals(a, b): Promise<boolean>

- Compares two WebElements for equality.

  #### Parameters

  - ##### a: WebElement

    A WebElement.

  - ##### b: WebElement

    A WebElement.

  #### Returns Promise<boolean>

  A promise that will be resolved to whether the two WebElements are equal.

  Inherited from OjSelectManyBase.equals

### `Static` extractId

- extractId(obj): string

- Extracts the encoded WebElement ID from the object.

  ### Throws

  if the object is not a valid encoded ID.

  #### Parameters

  - ##### obj: IWebElementId

    The object to extract the ID from.

  #### Returns string

  the extracted ID.

  Inherited from OjSelectManyBase.extractId

### `Static` isId

- isId(obj): boolean

- #### Parameters

  - ##### obj: IWebElementId

    the object to test.

  #### Returns boolean

  whether the object is a valid encoded WebElement ID.

  Inherited from OjSelectManyBase.isId

Generated using TypeDoc